<?php

define('HELPMARK','user_data.html#data_trends');
define('PRG_PATH','../../');

require_once('graphlib.php');
require_once(PRG_PATH . 'core/main.php');
require_once('slib.php');

getGlobalVar('select',$select);
getGlobalVar('id_c',$id_c);
getGlobalVar('id_t',$id_t);

getGlobalVar('profil_id',$profil_id);
getGlobalVar('prof_save',$prof_save);

getGlobalVar('efil',$efil);
getGlobalVar('enum',$enum);
getGlobalVar('ehdr',$ehdr);
getGlobalVar('etfm',$etfm);

getGlobalVar('em_to',$em_to);
getGlobalVar('em_subj',$em_subj);
getGlobalVar('em_text',$em_text);


getGlobalVar('search',$search);
getGlobalVar('dir',$dir);
getGlobalVar('offset',$offset);
getGlobalVar('stat',$stat);
getGlobalVar('table',$table);
getGlobalVar('drn',$drn);
getGlobalVar('type',$type);
getGlobalVar('ql',$ql);
getGlobalVar('dss',$dss);
getGlobalVar('dsd',$dsd);
getGlobalVar('sct',$sct);
getGlobalVar('drp',$drp);
getGlobalVar('gtype',$gtype);
getGlobalVar('capa',$capa);
getGlobalVar('bps',$bps); /* convert to the bits per second */
getGlobalVar('periface',$periface); /* show trend per every interface */

/* fields */
getGlobalVar('st',$st);
getGlobalVar('bytes',$bytes);
getGlobalVar('pck',$pck);
getGlobalVar('tos',$tos);
getGlobalVar('sip',$sip);
getGlobalVar('dip',$dip);
getGlobalVar('sipl',$sipl);
getGlobalVar('dipl',$dipl);
getGlobalVar('proto',$proto);
getGlobalVar('app',$app);
getGlobalVar('sp',$sp);
getGlobalVar('dp',$dp);
getGlobalVar('sif',$sif);
getGlobalVar('dif',$dif);
getGlobalVar('sas',$sas);
getGlobalVar('das',$das);
getGlobalVar('flg',$flg);
getGlobalVar('rt',$rt);
getGlobalVar('nh',$nh);

getGlobalVar('nst',$nst);
getGlobalVar('nbytes',$nbytes);
getGlobalVar('npck',$npck);
getGlobalVar('ntos',$ntos);
getGlobalVar('nsip',$nsip);
getGlobalVar('ndip',$ndip);
getGlobalVar('nsipl',$nsipl);
getGlobalVar('ndipl',$ndipl);
getGlobalVar('nproto',$nproto);
getGlobalVar('napp',$napp);
getGlobalVar('nsp',$nsp);
getGlobalVar('ndp',$ndp);
getGlobalVar('nsif',$nsif);
getGlobalVar('ndif',$ndif);
getGlobalVar('nsas',$nsas);
getGlobalVar('ndas',$ndas);
getGlobalVar('nrt',$nrt);
getGlobalVar('nnh',$nnh);


PageHead();
PageLogo();
MenuStart('data','MySubMenu');
PageTitle(x("Trends"),'i_trend.gif');
RequireRights("search");

if ($dir) {
  change_fields("sip","dip");
  change_fields("sipl","dipl");
  change_fields("sp","dp");
  change_fields("sif","dif");
  change_fields("sas","das");
}

if ($search=="export" || $search=="export2")
  RequireRights("export");

$list_coll=restriction_colllist(list_table("x_coll","ORDER BY name"));

get_table_select();

$error="";

if ($fields)
  $stat_list=trends_stat_list($fields);

if ($prof_save)
  profile_save($profil_id,"trends.php");

if ($search=="export")
  export_form();

if ($search=="email2" && !mail_test($em_to)) {
  MsgError(x("Invalid email address."));
  $search="email";
}
if ($search=="email")
  email_form();


if ($search && $search!="export" && $search!="email") {
  if (!$table)
    error_set(x("No table selected..."));
  if (!$fields)
    error_set(x("Can't load table fields ..."));
  if (!$stat_list[$stat])
    error_set(x("Selected statistic isn't available for current table."));
        
  $where="";
  $where_src="";
  $where_dst="";
  $where_srcr="";
  $where_dstr="";
  
  $networks=load_networks("ORDER BY name");
  if (strstr($fields,"sip")) {
    parse_ip($where_src,"sip",$sip,$nsip,$networks);
    parse_ip($where_src,"sip",load_network($sipl),$nsipl);
  }
  if (strstr($fields,"sp")) parse_port($where_src,"sp",$sp,$nsp);  
  if (strstr($fields,"sif")) parse_iface($where_src,"sif",$sif,$nsif);  
  if (strstr($fields,"sas")) parse_num($where_src,"sas",$sas,$nsas,0,65535);  

  if (strstr($fields,"dip")) {
    parse_ip($where_dst,"dip",$dip,$ndip,$networks);
    parse_ip($where_dst,"dip",load_network($dipl),$ndipl);    
  }
  if (strstr($fields,"dp")) parse_port($where_dst,"dp",$dp,$ndp);
  if (strstr($fields,"dif")) parse_iface($where_dst,"dif",$dif,$ndif);  
  if (strstr($fields,"das")) parse_num($where_dst,"das",$das,$ndas,0,65535);  


/* revers */
  if ($ql==2) {
    if (strstr($fields,"sip")&&strstr($fields,"dip")) {
      parse_ip($where_srcr,"dip",$sip,$nsip,$networks);
      parse_ip($where_srcr,"dip",load_network($sipl),$nsipl);    
    }
    if (strstr($fields,"sp")&&strstr($fields,"dp")) parse_port($where_srcr,"dp",$sp,$nsp);  
    if (strstr($fields,"sif")&&strstr($fields,"dif")) parse_iface($where_srcr,"dif",$sif,$nsif);  
    if (strstr($fields,"sas")&&strstr($fields,"das")) parse_num($where_srcr,"das",$sas,$nsas,0,65535);  

    if (strstr($fields,"dip")&&strstr($fields,"sip")) {
      parse_ip($where_dstr,"sip",$dip,$ndip,$networks);
      parse_ip($where_dstr,"sip",load_network($dipl),$ndipl);    
    }
    if (strstr($fields,"dp")&&strstr($fields,"sp")) parse_port($where_dstr,"sp",$dp,$ndp);
    if (strstr($fields,"dif")&&strstr($fields,"sif")) parse_iface($where_dstr,"sif",$dif,$ndif);  
    if (strstr($fields,"das")&&strstr($fields,"sas")) parse_num($where_dstr,"sas",$das,$ndas,0,65535);  
  }

  if ($where_src && $where_dst && $ql==2) 
    $where='((('.$where_src.') AND ('.$where_dst.')) OR (('.$where_srcr.') AND ('.$where_dstr.')))';
  elseif ($where_src && $where_dst && $ql==1) 
    $where='(('.$where_src.') OR ('.$where_dst.'))';
  elseif ($where_src && $where_dst) 
    $where='(('.$where_src.') AND ('.$where_dst.'))';
  elseif
    ($where_src) $where=$where_src;
  elseif
    ($where_dst) $where=$where_dst;

  
  if (strstr($fields,"proto")) parse_proto($where,"proto",$proto,$nproto);  
  if (strstr($fields,"app")) parse_app($where,"app",$app,$napp);  
  if (strstr($fields,"flags")) parse_flags($where,"flags",$flg);
  if (strstr($fields,"tos")) parse_tos($where,"tos",$tos,$ntos);  
  if (strstr($fields,"bytes")) parse_num($where,"bytes",$bytes,$nbytes);  
  if (strstr($fields,"pck")) parse_num($where,"pck",$pck,$npck);  
  if (strstr($fields,"st")) parse_time($where,"st",$st,$nst,get_table_start($table));  
  if (strstr($fields,"rt")) parse_ip($where,"rt",$rt,$nrt,$networks);
  if (strstr($fields,"nh")) parse_ip($where,"nh",$nh,$nnh,$networks);

  $where=restriction_cond($where,$id_c,$fields,$networks);
  
#  die("WHERE=$where<BR><BR>");

  if (!$error) {
    if ($rt) history_save("ip",$rt);
    if ($nh) history_save("ip",$nh);
    if ($st) history_save("st",$st);
    if ($bytes) history_save("bytes",$bytes);
    if ($pck) history_save("pck",$pck);
    if ($tos) history_save("tos",$tos);
    if ($sip) history_save("ip",$sip);
    if ($sp) history_save("port",$sp);
    if ($sif) history_save("if",$sif);
    if ($sas) history_save("as",$sas);
    if ($dip) history_save("ip",$dip);
    if ($dp) history_save("port",$dp);
    if ($dif) history_save("if",$dif);
    if ($das) history_save("as",$das);
    if ($proto) history_save("proto",$proto);
    if ($app) history_save("app",$app);
    if ($flg) history_save("flags",$flg);

    echo "<P CLASS=\"output\">\n";
    if ($periface && strstr($fields,"sif")!==false) {
      $periface_list=get_ifacelist($table,$where);
      $where_base=$where;
      foreach($periface_list as $pil) {
	if (isset($pil['rt'])) {
	  $where=($where_base)?('sif='.$pil['sif'].' AND rt='.$pil['rt'].' AND '.$where_base):('sif='.$pil['sif'].' AND rt='.$pil['rt']);
	  echo "<h2>".x("Interface").' '.xformat_interface(RESULT_GRAPH,$pil['sif'],$pil['rt'])."</h2>\n";
	}
	else {
	  $where=($where_base)?('sif='.$pil['sif'].' AND '.$where_base):('sif='.$pil['sif']);
	  echo "<h2>".x("Interface").' '.xformat_interface(RESULT_GRAPH,$pil['sif'])."</h2>\n";
	} 
	trends_make();
      }
    }
    else
      trends_make();
    echo "</P>\n";
  }
}


if (!$search||$error) {
  if ($error)
    MsgError($error);
        
  FormStart("trends.php");

  $list_net=list_table("x_network","ORDER BY name");
  $neg[0]=""; $neg[1]=x("not");
  
  echo InputHidden("table",$table);
  echo InputHidden("profil_id",$profil_id);
  popup_script("450","500");

  echo "<TABLE>\n";
  
  show_table_selector();
  
  echo "<TR><TD>";
  if ($table)
    MsgInfo(x("Statistics for collector")." <B>".$list_coll[$id_c]."</B><BR>".x("and")." <B>".$list_tables[$table]."</B>.");
  else
    MsgInfo(x("No table selected."));
  echo "</TD></TR>\n";
      
  if ($table) {
  echo "<TR VALIGN=\"top\">\n";
  echo "<TD WIDTH=\"50%\">\n";
    WinTStart();
    THItem(x("General parameters"),'COLSPAN="2"');
    TNext();
    TItem(x("Statistic:"));
    TItem(InputSelect("stat",select_list($stat_list,$stat)));
    TNext();
    TItem(x("Display:"));
    TItem(InputSelect("type",select_list($list_type,$type)));
    TNext();
    TItem(x("Graph type:"));
    TItem(InputSelect("gtype",select_list($list_gtype,$gtype)));
    TNext();
    TItem(x("Graph scale:"));
    TItem(InputSelect("sct",select_list($list_scale,$sct)));

    FItem("st",x("Time:"),Input("st",$st,255).show_history("st","st"));
    FItem("bytes",x("Bytes:"),Input("bytes",$bytes,255).show_history("bytes","bytes"));
    FItem("pck",x("Packets:"),Input("pck",$pck,255).show_history("pck","pck"));
    FItem("proto",x("Protocols:"),Input("proto",$proto,255).show_history("proto","proto").show_listproto("proto"));
    FItem("app",x("Applications:"),Input("app",$app,255).show_history("app","app").show_listapp("app"));
    if (strstr($fields,'flags')) {
      TNext();
      TItem(x("TCP flags:"));
      TItem(Input("flg",$flg,255).show_history("flags","flg"));
    }
    FItem("tos",x("Type of service:"),Input("tos",$tos,255).show_history("tos","tos"));
    FItem("nh",x("Next hop IP:"),Input("nh",$nh,255).show_history("ip","nh"));
    FItem("rt",x("Export device:"),Input("rt",$rt,255).show_history("ip","rt").show_listdev($id_c,"rt"));

    TNext();
    TItem(x("Logic:"));
    TItem(InputSelect("ql",select_list($list_ql,$ql)));
    WinEnd();
  echo "</TD>\n";
  echo "<TD WIDTH=\"50%\">\n";
    WinTStart();
    THItem(x("Optional parameters"),'COLSPAN="2"');
    TNext();
    TItem(InputCheck("drn","1",i_chk($drn)).x("don't resolve names"),'COLSPAN="2"');
    TNext();
    TItem(InputCheck("dss","1",i_chk($dss)).x("don't show sum total"),'COLSPAN="2"');
    TNext();
    TItem(InputCheck("drp","1",i_chk($drp)).x("display residual part"),'COLSPAN="2"');
    TNext();
    TItem(InputCheck("dsd","1",i_chk($dsd)).x("display exact size values"),'COLSPAN="2"');
    TNext();
    TItem(InputCheck("bps","1",i_chk($bps)).x("convert to bits per second"),'COLSPAN="2"');
    if (defined('CUSTOM_TRENDS_PER_INTERFACE') && strstr($fields,"sif")!==false) {
      TNext();
      TItem(InputCheck("periface","1",i_chk($periface)).x("show trends per interface"),'COLSPAN="2"');
    }
    TNext();
    TItem(x("Link capacity:"));
    TItem(Input("capa",$capa,10));
    WinEnd();
  echo "</TD>\n";
  echo "</TR><TR VALIGN=\"top\">\n";
  echo "<TD WIDTH=\"50%\">\n";
  if (strstr($fields,"sip")||strstr($fields,"sp")||strstr($fields,"sif")||strstr($fields,"sas")) {
    WinTStart();
    THItem(x("Sources"),'COLSPAN="2"');
    FItem("sip",x("IP address range:"),Input("sip",$sip,255).show_history("ip","sip"));
    if (strstr($fields,"sip")) {
      TNext();
      TItem(x("IP network list:"));
      TItem(InputSelect("nsipl",select_list($neg,$nsipl)).InputSelect("sipl",select_list(array("")+$list_net,$sipl)));
    }
    FItem("sp",x("Port range:"),Input("sp",$sp,255).show_history("port","sp"));
    FItem("sif",x("Interface:"),Input("sif",$sif,255).show_history("if","sif").show_listiface($id_c,"sif"));
    FItem("sas",x("AS range"),Input("sas",$sas,255).show_history("as","sas"));
    WinEnd();
  }
  echo "</TD>\n";
  echo "<TD WIDTH=\"50%\">\n";
  if (strstr($fields,"dip")||strstr($fields,"dp")||strstr($fields,"dif")||strstr($fields,"das")) {
    WinTStart();
    THItem(x("Destinations"),'COLSPAN="2"');
    FItem("dip",x("IP address range:"),Input("dip",$dip,255).show_history("ip","dip"));
    if (strstr($fields,"dip")) {
      TNext();
      TItem(x("IP network list:"));
      TItem(InputSelect("ndipl",select_list($neg,$ndipl)).InputSelect("dipl",select_list(array("")+$list_net,$dipl)));
    }
    FItem("dp",x("Port range:"),Input("dp",$dp,255).show_history("port","dp"));
    FItem("dif",x("Interface:"),Input("dif",$dif,255).show_history("if","dif").show_listiface($id_c,"dif"));
    FItem("das",x("AS range"),Input("das",$das,255).show_history("as","das"));
    WinEnd();
  }
  echo "</TD>\n";
  echo "</TR>\n";

  if ((strstr($fields,"dip")||strstr($fields,"dp")||strstr($fields,"dif")||strstr($fields,"das")) &&
     (strstr($fields,"sip")||strstr($fields,"sp")||strstr($fields,"sif")||strstr($fields,"sas")))
    $dir_label=InputSubmit("dir",x("Sources &lt;&gt; Destinations"));
  else
    $dir_label="";
  if ($profil_id)
    $prof_tmp=InputSubmit("prof_save",x("Modify profile"));
  else
    $prof_tmp=InputSubmit("prof_save",x("Save to profile")); 
  
  echo "<TR>";
    TItem("<br/>".InputSubmit("search",x("Search"))." ".$prof_tmp." ".$dir_label,'ALIGN="center" COLSPAN="2"');
  echo "</TR>\n";
  }
  echo "</TABLE>\n";
  FormEnd();
}


MenuEnd();
PageTail();









function trends_make() {
  global $type,$coll_id,$dss,$sct,$gtype,$drp,$search,$capa,$u_id,$bps;
  global $enum,$ehdr,$etfm,$export_handle;
  global $em_to,$em_subj,$em_text,$mail_message,$mail_headers;
  global $stat,$table,$xtable,$where,$fields,$name,$offset,$list_tables;
  global $u_timezone;


  $table=SQL_escape($table);

  if (get_table_info($table,$id_db,$fields,$minst,$maxst,$agg_c,$agg_w,$flag,$stype,$coll_id,$dt,$name,$step)==0)
    return 100;
  if (get_stat_format($stype,$list_tables[$table],$step,$statname,$timeformat))
    return 100;

  trends_maketemp();
  trends_query($stat,$caption,$wquery,$pquery,$tquery,$query,$axisy,$bps);
/*
echo "<br/>\nwquery:<br/>\n";
print_r($wquery);
echo "<br/>\npquery:<br/>\n";
print_r($pquery);
echo "<br/>\ntquery:<br/>\n";
print_r($tquery);
echo "<br/>\nquery:<br/>\n";
print_r($query);
echo "<br/>\n";
*/
  if ($bps)
    $cnv2bps=8/$step;
  else
    $cnv2bps=0;
  $rc=trends_matrix($wquery,$pquery,$tquery,$query,$matrix,$rows,$item,$items,$totalbytes,$cnv2bps);
  trends_droptemp();
  fixup_matrix($matrix,$minst,$step,$items);
  if ($rc)
    return;
  if ($pquery && $offset>0)
    $statname.=" ".x("results")." ".($offset+1)."-".($offset+$items);
  if ($rows) {
    if ($search!="export2") {
      if ($search=="email2")
        ob_start();

      if ($type==0 || $type==1) {
        if ($sct!=1) $sct=0;
        $graph_id=graph_create($caption,$statname,$gtype,$stype,'',$axisy,'',$sct,count_capacity($capa,$step,$bps));
        if ($graph_id) {
          $line="";
          for ($j=$minst;$j<=$maxst;$j+=$step)
            graph_addval($line,$j);
          graph_insert($graph_id,'x',$line,'');
          for ($i=0;$i<$items;$i++) {
            $line="";
            for ($j=$minst;$j<=$maxst;$j+=$step)
              graph_addval($line,$matrix[$i][$j]);
            graph_insert($graph_id,'y',$line,legend(RESULT_GRAPH,$item[$i]));      
          }
          if ($drp&&$tquery) {
            $line="";
            for ($j=$minst;$j<=$maxst;$j+=$step) {
              $sumay=0;
              for ($i=0;$i<$items;$i++)
  	        $sumay+=$matrix[$i][$j];
              graph_addval($line,$totalbytes[$j]-$sumay);
	    }
            graph_insert($graph_id,'y',$line,x("residual part"));    	
          }
	  $csim=$u_id."_".time();
	  generate_graph($graph_id,"",$u_id,$csim); /* generate CSIM */
          echo "<img src=\"graph.php?id=$graph_id&u_id=$u_id&timezone=$u_timezone\" alt=\"\" ISMAP USEMAP=\"#Map_$csim\" border=\"0\" />"; 
        }
        echo "<br/><br/>\n";
      }

      if ($pquery && $search!="email2") {
	echo "<BR>\n";
	ShowNavigate("trends.php",($items==10)?($items+1):($items),$offset,10);
	echo "<BR><BR>\n";
      }

      if ($type==0 || $type==2) {
        WinStart($caption);
        THItem(x("Time"));
        if ($items) {
          for ($i=0;$i<$items;$i++)
            THItem(legend(RESULT_HTML,$item[$i]),'VALIGN="top" NOWRAP');
	  if ($drp&&$tquery)
	    THItem(x("Residual part"));
        }
        $suma=array();
        for ($j=$minst;$j<=$maxst;$j+=$step) {
          $sumay=0;
	  for ($i=0;$i<$items;$i++)
	    $sumay+=$matrix[$i][$j];
    	
          TLine();
          TItem(strftime($timeformat,$j),'ALIGN="right"');
          for ($i=0;$i<$items;$i++) {
	    $perc=0;
	    if ($totalbytes[$j])
	      $perc=($matrix[$i][$j]/$totalbytes[$j])*100;
	    elseif ($items>1 && $sumay!=0)
	      $perc=($matrix[$i][$j]/$sumay)*100;	    
            TItem(xformat_bytes_pck(0,$matrix[$i][$j],$perc),'ALIGN="right"');
	    $suma[$i]+=$matrix[$i][$j];
          }
          if ($drp&&$tquery) {
	    $perc=(($totalbytes[$j]-$sumay)/$totalbytes[$j])*100;
	    TItem(xformat_bytes_pck(0,$totalbytes[$j]-$sumay,$perc),'ALIGN="right"');
	    $suma[$items]+=($totalbytes[$j]-$sumay);
          }
        }
        if (!$dss) {
          TLine();
          TItem("<B>".x("Sum total")."</B>",'ALIGN="right"');
          for ($i=0;$i<$items;$i++)
	    TItem("<B>".xformat_bytes_pck(0,$suma[$i])."</B>",'ALIGN="right"');
          if ($drp&&$tquery)
	    TItem("<B>".xformat_bytes_pck(0,$suma[$items])."</B>",'ALIGN="right"');
        }
        WinEnd();
      }

      if ($pquery && $search!="email2") {
	echo "<BR><BR>\n";
	ShowNavigate("trends.php",($items==10)?($items+1):($items),$offset,10);
      }


      if ($search=="email2") {
        $cnt=ob_get_contents();
	ob_end_clean();
	$cnt=pregi_replace_repeat("</A>","",$cnt);
	$cnt=pregi_replace_repeat("<A ","<IGNORE ",$cnt);
	$cnt=pregi_replace_repeat("onmouseover=","ignoretag=",$cnt);
	$cnt=pregi_replace_repeat("onmouseout=","ignoretag=",$cnt);
	$cnt=pregi_replace_repeat("<img ","<ignore ",$cnt);

	if ($em_to) history_save("email",$em_to);
	if ($em_subj) history_save("email_subj",$em_subj);
        if (!$em_subj)
	  $em_subj=PRG_NAME;
        if (!$em_text)
	  $em_text=x("Trends statistic is stored in the attachment...");

        $bound=mail_init();
        mail_text($bound,$em_text);
        mail_attcs($bound,$cnt,"trends.html","text/html");
        if ($type==0 || $type==1) {
	  $em_gh=generate_graph($graph_id,_IMG_HANDLER,$u_id);
	  if ($em_gh) {
	    ob_start();
	    imagepng($em_gh);
	    $em_gr=ob_get_contents();
	    ob_end_clean();
            mail_attcs($bound,$em_gr,"graph.png","image/png");
	  }
        }
        mail_finish($bound);
        mail_head($bound,"");
        if (mail($em_to,$em_subj,$mail_message,$mail_headers))
          MsgInfo(x("Statistic was sent to email:")."<BR>$em_to");
        else
          MsgError(x("Error while sending statistic to the email."));
      }

    }  


    if ($search=="export2") {
      $export_name=export_name("trends");
      export_open($export_name);
      if ($ehdr) {
        unset($line);
        $line[]=x("Time");
        if ($items) {
          for ($i=0;$i<$items;$i++)
            $line[]=legend(RESULT_PLAIN,$item[$i]);
	  if ($drp&&$tquery)
	    $line[]=x("Residual part");
        }
        myfputcsv($export_handle,$line);
      }
      
      $suma=array();
      for ($j=$minst;$j<=$maxst;$j+=$step) {
        $sumay=0;
	unset($line);
        $line[]=strftime($timeformat,$j);
        for ($i=0;$i<$items;$i++) {
          if ($matrix[$i][$j]) {
            $line[]=$matrix[$i][$j];
	    $suma[$i]+=$matrix[$i][$j];
	  }
	  else
	    $line[]="0";
	  $sumay+=$matrix[$i][$j];
        }
        if ($drp&&$tquery) {
	  $line[]=$totalbytes[$j]-$sumay;
	  $suma[$items]+=($totalbytes[$j]-$sumay);
        }
	myfputcsv($export_handle,$line);
      }
      
      if (!$dss) {
        unset($line);
        $line[]=x("Sum total");
        for ($i=0;$i<$items;$i++)
	  $line[]=$suma[$i];
        if ($drp&&$tquery)
	  $line[]=$suma[$items];
	myfputcsv($export_handle,$line);
      }
      export_close();
      MsgInfo(x("Export was saved to file:")."<br>".ShowLink($export_name,PRG_PATH."src/exports/export.php"));
    }
  }
  else
    MsgInfo(x("No records matching your query found."));
}



function MySubMenu() {
  global $search,$id_c,$id_t;
  
  $mysubmenu[]=array('caption'=>x("New query"),'url'=>"trends.php?id_t=$id_t&id_c=$id_c");
  if ($search) {
    $mysubmenu[]=array('caption'=>x("Redefine"),'url'=>"trends.php?".args("search=0"));
    $mysubmenu[]=array('caption'=>x("Email result"),'url'=>"trends.php?".args("search=email"));
    if (CheckRights("export"))
      $mysubmenu[]=array('caption'=>x("Export"),'url'=>"trends.php?".args("search=export"));
  }
  MenuSub(x("Trends"),$mysubmenu);
}


?>
