<?php
define('HELPMARK','data_utilmap_pth.html');
define('PRG_PATH','../../');
require_once(PRG_PATH . 'core/main.php');
require_once('utillib.php');

getGlobalVar('command',$command);
getGlobalVar('c__num',$c__num);
getGlobalVar('btn_save',$btn_save);
getGlobalVar('subdelete',$subdelete);
getGlobalVar('dlg_yes',$dlg_yes);
getGlobalVar('c__sel',$c__sel);


getGlobalVar('id',$id);
getGlobalVar('id_map',$id_map);
getGlobalVar('id_src',$id_src);
getGlobalVar('id_dst',$id_dst);
getGlobalVar('type',$type);
getGlobalVar('weight',$weight);

PageHead();
PageLogo();
MenuStart('data','MySubMenu');
PageTitle(x("Utilization maps - paths"),'i_utilmap.gif');
demo_die();
RequireRights("utilmap");


if ($subdelete)
  $command="delete";

check_command('add','addsubmit','delete','deletesubmit','edit','editsubmit');

$list_obj=list_table("x_utilobj","WHERE id_map='".SQL_escape($id_map)."'");


$list_wei[1]="1";
$list_wei[2]="2";
$list_wei[3]="3";
$list_wei[4]="4";
$list_wei[5]="5";
$list_wei[6]="6";


if (!$id_map)
  MsgFatal(x("No map selected ..."));


if (!is_array($list_obj) || !count($list_obj))
  MsgFatal(x("Two valid objects must exists at minimum."));


if ($command=="addsubmit") {
    $v=SQL_escape(array($id_map,$id_src,$id_dst,$type,$weight));
    if (!req_var($id_src,x("source")))
      $command="add";
    else
    if (!req_var($id_dst,x("destination")))
      $command="add";
    else
    if ($id_src == $id_dst) {
      MsgError(x("Source is same as destination! Choose another source or destination object."));
      $command="add";
    }
    else
    if (SQL_query("INSERT INTO x_utilpth (id_map,id_src,id_dst,type,weight) 
	VALUES('$v[0]','$v[1]','$v[2]','$v[3]','$v[4]')")) {
      MsgInfo(x("Path created successfully ..."));
      $command="";
    }
    else {
      MsgError(x("Insert failed. Maybe you tried inserting duplicate path."));
      $command="add";
    }
}



if ($command=="editsubmit") {
    $v=SQL_escape(array($id,$id_map,$id_src,$id_dst,$type,$weight));
    if (!req_var($id_src,x("source")))
      $command="edit";
    else
    if (!req_var($id_dst,x("destination")))
      $command="edit";
    else
    if ($id_src == $id_dst) {
      MsgError(x("Source is same as destination! Choose another source or destination object."));
      $command="edit";
    }
    else
    if (SQL_query("UPDATE x_utilpth SET id_src='$v[2]',id_dst='$v[3]',type='$v[4]',weight='$v[5]' WHERE id='$v[0]' ANd id_map='$v[1]'")) {
      MsgInfo(x("Path updated successfully ..."));
      $command="";
    }
    else {
      MsgError(x("Update failed. Maybe you tried inserting duplicate path."));
      $command="edit";
    }
}



if ($command=="deletesubmit") {
  if (($dlg_yes)&&($c__num)&&($c__sel)) {
    for ($i=0;$i<$c__num;$i++) {
      $id="";
      getGlobalVar("c__$i",$id);
      if ($id) {
	$v=SQL_escape($id);
	SQL_query("LOCK TABLES x_utilpth WRITE");

	$res=SQL_query("SELECT id_src,id_dst FROM x_utilpth WHERE id='$v'");
	if ($res) {
          $row=SQL_fetch_array($res);
	  $id_src=$row[0];
	  $id_dst=$row[1];
          SQL_free_result($res);
        }

        if (!SQL_query("DELETE FROM x_utilpth WHERE id='$v'")) {
	  MsgError(x("Delete failed. Path from %s to %s wasn't deleted."),$list_obj[$id_src],$list_obj[$id_dst]);
	  $error=1;
	}
	
        SQL_query("UNLOCK TABLES");
      }
    }
    if (!$error)
      MsgInfo(x("Selected paths were deleted ...")); 
  }
  $command="";
}



if (($command=="add")||($command=="edit")) {
    if (!$btn_save&&$command=="edit") {
      $v=SQL_escape($id);
      $res=SQL_query("SELECT id_src,id_dst,type,weight FROM x_utilpth WHERE id='$v'");
      if ($res) {
        $row=SQL_fetch_array($res);
	$id_src=$row[0];
	$id_dst=$row[1];
	$type=$row[2];
	$weight=$row[3];
        SQL_free_result($res);
      }
    }
    FormStart();
    echo InputHidden("id",$id);
    echo InputHidden("id_map",$id_map);
    
    if ($command=="add") {
      echo InputHidden("command","addsubmit");
      WinStart(x("Add new path"));
    }  
    else {
      echo InputHidden("command","editsubmit");
      WinStart(x("Edit path"));
      TItem(x("Path ID:"));
      TItem("<B>$id</B>");
      TNext();
    }
    TItem(x("Source:"));
    TItem(InputSelect("id_src",select_list($list_obj,$id_src)));
    TNext();
    TItem(x("Destination:"));
    TItem(InputSelect("id_dst",select_list($list_obj,$id_dst)));
    TNext();
    TItem(x("Weight:"));
    TItem(InputSelect("weight",select_list($list_wei,$weight)));
    TNext();
    TNext();
    TItem("<BR>".InputSubmit("btn_save",x("Save")),'COLSPAN="2" ALIGN="center"');
    WinEnd();

    echo "<BR><BR>\n";
    WinStart(x("Stored map preview"));
    TItem(ShowImage("MAP_".$id_map,"utilimg.php?id=$id_map&show=1"));
    WinEnd();

    FormEnd();
}



if ($command=="delete") {
  $v=SQL_escape($id);
  if ($c__num) {
    FormStart();
    echo InputHidden("command","deletesubmit");
    echo InputHidden("id_map",$id_map);
    echo InputHidden("c__num",$c__num);
    $j=0;
    for ($i=0;$i<$c__num;$i++) {
      $c__tmp="";
      getGlobalVar("c__$i",$c__tmp);
      if ($c__tmp) {
        echo InputHidden("c__$i",$c__tmp);
	$j++;
      }
    }
    Dialog(MSGDLG_YESNO,"",x("Do you want to delete the selected paths?"));
    echo InputHidden("c__sel",$j);
    FormEnd();
  }
  else
    $command="";
}



if ($command=="") {
  $res=SQL_query("SELECT id,id_src,id_dst,type,weight FROM x_utilpth WHERE id_map='".SQL_escape($id_map)."' ORDER BY id_src,weight DESC,id_dst");
  if ($res) {
    if (SQL_num_rows($res)) {
      FormStart();
      JSInvert();
      WinTStart();
      THItem(ShowInvert());
      THItem(x("Source object"));
      THItem(x("Destination object"));
      THItem(x("Weight"));
      THItem(x("Command"));
      $i=0;
      while (($row=SQL_fetch_array($res))) {
        TLine();
	TItem(InputCheck("c__$i",$row[0]));
	TItem($list_obj[$row[1]]);
	TItem($list_obj[$row[2]]);
	TItem($row[4]);
	TItem(ShowLink(x("Edit"),"utilpth.php?command=edit&id_map=$id_map&id=$row[0]"),'ALIGN="center"');
	$i++;
      }
      TNext();
      TItem("<BR>".InputSubmit("subdelete",x("Delete")),'COLSPAN="6" ALIGN="center"');
      WinEnd();
      echo InputHidden("c__num",$i);
      echo InputHidden("id_map",$id_map);
      FormEnd();
    }
    else
      MsgInfo(x("No rows found ..."));
    SQL_free_result($res);
  }
  else
    MsgError(x("Database error"));

  echo "<BR><BR>\n";
  WinStart(x("Stored map preview"));
  TItem(ShowImage("MAP_".$ip_map,"utilimg.php?id=$id_map&show=1"));
  WinEnd();
}

MenuEnd();
PageTail();




function MySubMenu() {
  global $id_map;

  $mysubmenu[]=array('caption'=>x("List map"),'url'=>'utilmap.php');
  $mysubmenu[]=array('caption'=>x("Edit map"),'url'=>"utilmap.php?command=edit&id=$id_map");
  $mysubmenu[]=array('caption'=>x("List objects"),'url'=>"utilobj.php?id_map=$id_map");
  $mysubmenu[]=array('caption'=>x("List paths"),'url'=>"utilpth.php?id_map=$id_map");
  $mysubmenu[]=array('caption'=>x("Add path"),'url'=>"utilpth.php?command=add&id_map=$id_map");
  MenuSub(x("Utilization map"),$mysubmenu);
}


?>