<?php
define('HELPMARK','config_anomalies_exl.html');
define('PRG_PATH','../../');
require_once(PRG_PATH . 'core/main.php');
require_once(PRG_PATH . 'src/anomaly/modules.php');

getGlobalVar('command',$command);

getGlobalVar('c__num',$c__num);
getGlobalVar('subdelete',$subdelete);
getGlobalVar('dlg_yes',$dlg_yes);
getGlobalVar('c__sel',$c__sel);

if ($subdelete)
  $command="delete";

PageHead();
PageLogo();
MenuStart('options','MySubMenu');
PageTitle(x("Network anomalies - Exclusions"),'i_anomaly.gif');
RequireRights("options");

check_command('delete','deletesubmit');
demo_cmd("deletesubmit");

$list_coll=list_table("x_coll","ORDER BY name");

if (!is_array($list_coll)|| !count($list_coll))
  MsgFatal(x("No available collector. Go to menu Options-&gt;Collectors first."));

if (!is_array($na_mod) || !count($na_mod))
  MsgFatal(x("No available network anomaly module."));

FormStart();


if ($command=="deletesubmit") {
  if (($dlg_yes)&&($c__num)&&($c__sel)) {
    for ($i=0;$i<$c__num;$i++) {
      $id="";
      getGlobalVar("c__$i",$id);
      if ($id) {
	$v=SQL_escape($id);	
        if (!SQL_query("DELETE FROM x_na_ign WHERE id='$v'")) {
	    MsgError(x("Delete failed. Network anomaly exclusion wasn't deleted."));
	    $error=1;
        }
      }
    }
    if (!$error)
      MsgInfo(x("Selected exclusions were deleted ...")); 
  }
  $command="";
}


if ($command=="delete") {
  $v=SQL_escape($id);
  if ($c__num) {
    FormStart();
    echo InputHidden("command","deletesubmit");
    echo InputHidden("c__num",$c__num);
    $j=0;
    for ($i=0;$i<$c__num;$i++) {
      $c__tmp="";
      getGlobalVar("c__$i",$c__tmp);
      if ($c__tmp) {
        echo InputHidden("c__$i",$c__tmp);
	$j++;
      }
    }
    Dialog(MSGDLG_YESNO,"",x("Do you want to delete the selected exclusions?"));
    echo InputHidden("c__sel",$j);
    FormEnd();
  }
  else
    $command="";
}


if ($command=="") {   
  $res=SQL_query("SELECT * FROM x_na_ign ORDER BY et,cid,na,nas,src,dst");
  if ($res) {
    $count=SQL_num_rows($res);
    if ($count) {
      JSInvert();
      WinStart(x("Network anomalies exclusions"));
      THItem(ShowInvert());
      THItem(x("Exclude to"));
      THItem(x("Collector"));
      THItem(x("Anomaly"));
      THItem(x("Source"));
      THItem(x("Destination"));
      $i=0;
      while ($row=SQL_fetch_array($res)) {
        TLine();
        TItem(InputCheck("c__$i",$row['id']));
        TItem(($row['et']!=0)?strftime("%x %X",$row['et']):x("Forever"));
        TItem(($row['cid']!='*')?$list_coll[$row['cid']]:x("Any collector"));
	if ($row['na']!='*' && $row['nas']!='*' )
	  TItem($na_mod[$row['na']]['name']." - ".$na_mod[$row['na']]['nas'][$row['nas']]);
	elseif ($row['na']!='*')
	  TItem($na_mod[$row['na']]['name']);
	else
	  TItem(x("Any anomaly"));
	switch ($row['srct']) {
	  default:
	  case '*': TItem(x("Any source")); break;
	  case '0': TItem(x("N/A")); break;
	  case '1': TItem(($row['src']!='*')?xformat_ip(0,$row['src']):x("Any IP address")); break;
	}
	switch ($row['dstt']) {
	  default:
	  case '*': TItem(x("Any destination")); break;
	  case '0': TItem(x("N/A")); break;
	  case '1': TItem(($row['dst']!='*')?xformat_ip(0,$row['dst']):x("Any IP address")); break;
	}
        $i++;
      }
      TNext();
      TItem("<br/>".InputSubmit("subdelete",x("Delete exclusions")),'colspan="6" align="center"');
      WinEnd();    
      echo InputHidden("c__num",$i);
    }
    else
      MsgInfo(x("No network anomaly(ies) exclusion found.")."<br/><br/>\n".
    	      x("In the menu 'Anomalies' click on the 'Source' or 'Destination' of anomaly to exclude it."));
  }
  else
    MsgError(x("Database error"));  
}


FormEnd();
MenuEnd();
PageTail();




/*  F U N C T I O N S  */



function MySubMenu() {
  global $command,$cid;
  if ($command=="module" || $command=="modulesave")
    $mysubmenu[]=array('caption'=>x("Edit collector"),'url'=>"anomaly.php?command=coll&cid=$cid");
  $mysubmenu[]=array('caption'=>x("Global"),'url'=>'anomaly_glb.php');
  $mysubmenu[]=array('caption'=>x("Collectors"),'url'=>'anomaly.php');
  $mysubmenu[]=array('caption'=>x("Exclusions"),'url'=>'anomaly_exl.php');
  MenuSub(x("Anomalies"),$mysubmenu);
}





?>