<?php
define('HELPMARK','config_devices.html');
define('PRG_PATH','../../');
require_once(PRG_PATH . 'core/main.php');

getGlobalVar('btn_save',$btn_save);
getGlobalVar('count',$count);

getGlobalVar('id',$id);

PageHead();
PageLogo();
MenuStart('options','MySubMenu');
PageTitle(x("Devices - Interfaces"),'i_device.gif');
RequireRights("options");

demo_die();

if (!$id)
  MsgFatal(x("Unknown device, go to Options-&gt;Devices first."));

if ($btn_save) {
  if ($count) {
    $query="";
    for ($i=0;$i<$count;$i++) {
      getGlobalVar("i__$i",$ifindex);
      getGlobalVar("n__$i",$name);
      getGlobalVar("c__$i",$comment);
      if ($name || $comment) {
        $v=SQL_escape(array($id,$ifindex,$name,$comment));
        SQL_query("REPLACE x_iface SET did='$v[0]',ifindex='$v[1]',name='$v[2]',comment='$v[3]'");
      }
    }
    MsgInfo(x("Interface names updated."));
  }
}



$v=SQL_escape($id);
$res=SQL_query("SELECT * FROM x_device WHERE id='$v'");
if ($res) {
  $row=SQL_fetch_array($res);
  $name=$row['name'];
  $ip=$row['ip'];
  $snmp=$row['snmp_enabled'];
  $community=$row['snmp_community'];
  SQL_free_result($res);
}
else
  MsgFatal(x("Database error"));

if (!$ip || !$snmp)
  MsgFatal(x("Selected device has not assigned IP address and/or enabled SNMP."));

if (!is_ip($ip))
  MsgFatal(x("Selected device has not assigned valid IP address."));

$list_iface=get_snmp_iface($ip,$community);
$list_sql_iface=get_sql_iface($id);

if (!is_array($list_iface) || count($list_iface)==0)
  MsgFatal(x("Cannot read SNMP values. Check your SNMP community or connection."));

FormStart();
echo InputHidden("id",$id);
WinStart(x("Interface names for device %s (%s)",$name,$ip));
THItem(x("IfIndex"));
THItem(x("Description"));
THItem(x("Name"));
THItem(x("Comment"));

$num=0;
while (list($ifindex,$desc)=each($list_iface)) {
  $name="";
  $comment="";
  if (count($list_sql_iface) && count($list_sql_iface[$ifindex])) {
    $name=$list_sql_iface[$ifindex][0];
    $comment=$list_sql_iface[$ifindex][1];
  }
  TLine();
  echo InputHidden("i__$num",$ifindex);
  TItem($ifindex);
  TItem($desc);
  TItem(Input("n__$num",$name,16));
  TItem(Input("c__$num",$comment,255));
  $num++;
}
TNext();
TItem("<BR>".InputSubmit("btn_save",x("Save changes")),'COLSPAN="4" ALIGN="center"');
WinEnd();
echo InputHidden("count",$num);
FormEnd();

MenuEnd();
PageTail();


function get_snmp_iface($ip,$community) {
  $list_iface=array();
  $ifIndex = @my_snmpwalk($ip,$community,".1.3.6.1.2.1.2.2.1.1");
  $ifDescr = @my_snmpwalk($ip,$community,".1.3.6.1.2.1.2.2.1.2");
  reset($ifIndex);
  while (list($key,$val) = each($ifIndex)) {
    $list_iface[$val]=$ifDescr[$key];
  }
  return $list_iface;
}

function get_sql_iface($dev) {
  $ret=array();
  $v=SQL_escape($dev);
  $res=SQL_query("SELECT * FROM x_iface WHERE did='$v'");
  if ($res) {
    while ($row=SQL_fetch_array($res))
      $ret[$row['ifindex']]=array($row['name'],$row['comment']);
    SQL_free_result($res);
  }
  return $ret;
}


function MySubMenu() {
  global $id;
  $mysubmenu[]=array('caption'=>x("List"),'url'=>'devices.php');
  $mysubmenu[]=array('caption'=>x("Add"),'url'=>'devices.php?command=add');
  $mysubmenu[]=array('caption'=>x("Edit"),'url'=>"devices.php?command=edit&id=$id");
  $mysubmenu[]=array('caption'=>x("Discover"),'url'=>'devices_dc.php');
  MenuSub(x("Devices"),$mysubmenu);
}


?>