<?php
define('HELPMARK','status_tables.html');
define('PRG_PATH','../../');
require_once(PRG_PATH . 'core/main.php');

getGlobalVar('command',$command);
getGlobalVar('start',$start);
getGlobalVar('c__num',$c__num);
getGlobalVar('btn_save',$btn_save);
getGlobalVar('subdelete',$subdelete);
getGlobalVar('subexport',$subexport);
getGlobalVar('dlg_yes',$dlg_yes);
getGlobalVar('c__sel',$c__sel);

getGlobalVar('id',$id);
getGlobalVar('table',$table);

PageHead();
PageLogo();
MenuStart('status','MySubMenu');
PageTitle(x("Tables status"),'i_table.gif');
RequireRights("status");

if ($subdelete)
  $command="delete";
if ($subexport)
  $command="export";

if (CheckRights("export"))
  check_command('detail','delete','deletesubmit','export','exportsubmit');
else
  check_command('detail','delete','deletesubmit');

demo_cmd("deletesubmit");
demo_cmd("exportsubmit"); 


$list_coll=list_table("x_coll","ORDER BY name");

if ($start && is_array($list_coll)) {
  reset($list_coll);
  list($table,$tablename)=each($list_coll);
  reset($list_coll);
}

if ($command=="deletesubmit") {
  if (($dlg_yes)&&($c__num)&&($c__sel)) {
    for ($i=0;$i<$c__num;$i++) {
      $id="";
      getGlobalVar("c__$i",$id);
      if ($id) {
        $name="";
	$v=SQL_escape($id);
	SQL_query("LOCK TABLES x_table WRITE");

	$res=SQL_query("SELECT name,flag,agg_w FROM x_table WHERE id='$v'");
	if ($res) {
          $row=SQL_fetch_array($res);
	  $name=$row[0];
	  $flag=$row[1];
	  $agg_w=$row[2];
          SQL_free_result($res);
        }
	if ($flag || $agg_w) {
	  MsgError(x("Table %s can't be removed, because this table is in use."),$name);
	  $error=1;	
	}
        elseif ($name && !SQL_query("DROP TABLE IF EXISTS $name")) {
	  MsgError(x("Drop failed. Table %s wasn't removed."),$name);
	  $error=1;
	}
	elseif (!SQL_query("DELETE FROM x_table WHERE id='$v'")) {
	  MsgError(x("Delete failed. Table %s removed, but still is in x_table."),$name);
	  $error=1;
	}
	
        SQL_query("UNLOCK TABLES");
      }
    }
    if (!$error)
      MsgInfo(x("Selected tables were deleted ...")); 
  }
  $command="";
}


if ($command=="delete") {
  $v=SQL_escape($id);
  if ($c__num) {
    FormStart();
    echo InputHidden("command","deletesubmit");
    echo InputHidden("table",$table);
    echo InputHidden("c__num",$c__num);
    $j=0;
    for ($i=0;$i<$c__num;$i++) {
      $c__tmp="";
      getGlobalVar("c__$i",$c__tmp);
      if ($c__tmp) {
        echo InputHidden("c__$i",$c__tmp);
	$j++;
      }
    }
    Dialog(MSGDLG_YESNO,"",x("Do you want to delete the selected tables?"));
    echo InputHidden("c__sel",$j);
    FormEnd();
  }
  else
    $command="";
}


if ($command=="exportsubmit") {
  if (($dlg_yes)&&($c__num)&&($c__sel)) {
    for ($i=0;$i<$c__num;$i++) {
      $id="";
      getGlobalVar("c__$i",$id);
      if ($id) {
	$v=SQL_escape($id);
	$name="";
	$res=SQL_query("SELECT name FROM x_table WHERE id='$v'");
	if ($res) {
          $row=SQL_fetch_array($res);
	  $name=$row[0];
          SQL_free_result($res);
        }
	if ($name=="") {
	  MsgError(x("Can't find table with ID %s."),$id);
	  $error=1;		
	}
	elseif ($name[0]!="h" && $name[0]!="d" && $name[0]!="w" && $name[0]!="m") {
	  MsgError(x("Adding table to export queue failed. Table %s cann't be exported, because it is exported already."),$name);
	  $error=1;	
	}
	elseif (!SQL_query("INSERT INTO x_expimp (name,type,state,itime,mtime) VALUES ('$name','export','waiting',".time().",".time().")")) {
	  MsgError(x("Adding table to export queue failed. Table %s won't be exported."),$name);
	  $error=1;
	}
      }
    }
    if (!$error)
      MsgInfo(x("Selected tables were prepared for export... Export start in 15 minutes.")); 
  }
  $command="";
}


if ($command=="export") {
  $v=SQL_escape($id);
  if ($c__num) {
    FormStart();
    echo InputHidden("command","exportsubmit");
    echo InputHidden("table",$table);
    echo InputHidden("c__num",$c__num);
    $j=0;
    for ($i=0;$i<$c__num;$i++) {
      $c__tmp="";
      getGlobalVar("c__$i",$c__tmp);
      if ($c__tmp) {
        echo InputHidden("c__$i",$c__tmp);
	$j++;
      }
    }
    Dialog(MSGDLG_YESNO,"",x("Do you want to export the selected tables?"));
    echo InputHidden("c__sel",$j);
    FormEnd();
  }
  else
    $command="";
}



if ($command=="detail") {
  $res=SQL_query("SELECT id,name,id_db,flag,agg_w,st,et,agg_c FROM x_table WHERE id='".SQL_escape($id)."'");
  if ($res) {
    $row1=SQL_fetch_array($res);
    SQL_free_result($res);
  }
  else
    MsgError(x("Database error"));

  if ($row1) {
    $res=SQL_query("SHOW TABLE STATUS like '".SQL_escape($row1[1])."'");
    if ($res) {
      $row2=SQL_fetch_array($res);
      SQL_free_result($res);
    }
    else
      MsgError(x("Database error"));
  }
    
  FormStart();
  WinTStart();
  if ($row1 && $row2) {
      TItem(x("Name:"));
      TItem("<B>".$row1[1]."</B>");
      TLine();
      TItem(x("Type:"));
      TItem(table_gettype($row1[1]));
      TLine();
      TItem(x("From:"));
      TItem(strftime("%x %X",$row1[5])." (".$row1[5].")");
      TLine();
      TItem(x("To:"));
      TItem(strftime("%x %X",$row1[6])." (".$row1[6].")");
      TLine();
      TItem(x("Flag:"));
      TItem(table_getflag($row1[3],$row1[4]));
      TLine();
      TItem(x("Rows:"));
      TItem($row2['Rows']." (".number2human($row2['Rows']).")");
      TLine();
      TItem(x("Data length:"));
      TItem($row2['Data_length']." (".number2human($row2['Data_length']).")");
      TLine();
      TItem(x("Index length:"));
      TItem($row2['Index_length']." (".number2human($row2['Index_length']).")");
      TLine();
      TItem(x("Total length:"));
      TItem($row2['Data_length']+$row2['Index_length']." (".number2human($row2['Data_length']+$row2['Index_length']).")");
      TLine();
      TItem(x("Including:"),'VALIGN="top"');
      TItem(preg_replace("#,#", "<BR>", $row1[7]));
  }
  WinEnd();
  FormEnd();
}

if ($command=="") {
  FormStart("","tables");
  echo InputHidden("start",0);
  WinStart(x("Collector"));  
  TItem(InputSelect("table",select_list(array(x("*** all collectors ***"))+$list_coll,$table),($u_java)?"onchange=\"this.form.submit();\"":""));
  TItem(InputSubmit("send",x("Select")));
  WinEnd();
  FormEnd();
  if ($table)
    $res=SQL_query("SELECT id,name,id_db,flag,agg_w,st,et FROM x_table WHERE name like '_".SQL_escape($table)."\_%' ORDER BY id_db,name");
  else  
    $res=SQL_query("SELECT id,name,id_db,flag,agg_w,st,et FROM x_table ORDER BY id_db,name");
  if ($res) {
     if (SQL_num_rows($res)) {
      FormStart();
      JSInvert();
      WinTStart();
      THItem(ShowInvert());
      THItem(x("Name"));
      THItem(x("Type"));
      THItem(x("From"));
      THItem(x("To"));
      THItem(x("Flag"));
      THItem(x("Command"));
      $i=0;
      while (($row=SQL_fetch_array($res))) {
        TLine();
	TItem((!$row[3]&&!$row[4])?InputCheck("c__$i",$row[0]):"");
	TItem($row[1]);
	TItem(table_gettype($row[1]));
	TItem(strftime("%x %X",$row[5]));
	TItem(strftime("%x %X",$row[6]));
	TItem(table_getflag($row[3],$row[4]));
	TItem(ShowLink(x("Detail"),"tables.php?command=detail&id=$row[0]&table=$table"),'ALIGN="center"');
	$i++;
      }
      TNext();
      TItem("<BR>".InputSubmit("subdelete",x("Delete")).((CheckRights("export"))?InputSubmit("subexport",x("Export")):""),'COLSPAN="7" ALIGN="center"');
      WinEnd();
      echo InputHidden("c__num",$i);
      echo InputHidden("table",$table);
      FormEnd();
    }
    else
      MsgInfo(x("No tables found ..."));
    SQL_free_result($res);
  }
  else
    MsgError(x("Database error"));
}

MenuEnd();
PageTail();


function table_gettype($name) {
  $stype=substr($name,0,1);  
  switch ($stype) {
    case 'h':
    case 'o':
	return x("hourly");
    case 'd':
    case 'p':
	return x("daily");
    case 'w':
    case 'q':
	return x("weekly");
    case 'm':	
    case 'r':
	return x("monthly");
  }
  return x("unknown");
}

function table_getflag($flag,$agg_w) {
  if ($agg_w)
    return x("moving data");
  if (!strcasecmp($flag,"A"))
    return x("previous hour");
  if (!strcasecmp($flag,"C"))
    return x("actual hour");
  if (!strcasecmp($flag,"B"))
    return x("next hour");
  return "";
}

function MySubMenu() {
  global $table;
  $mysubmenu[]=array('caption'=>x("List"),'url'=>"tables.php?table=$table");
  MenuSub(x("Tables"),$mysubmenu);
}



?>